=== logs/Makefile ===
all:
	gnuplot graphs.dem
