=== debian/changelog ===
libreoffice (4:25.8.2-0ubuntu0.25.10.1) questing; urgency=medium

  * New upstream release (LP: #2126932)
  * Bump yaru source to "2025-09-07"

 -- Rico Tzschichholz <ricotz@ubuntu.com>  Thu, 02 Oct 2025 12:22:43 +0200
